-- Simple selections

SELECT * FROM [Producers]

SELECT [BrandID], [Name] FROM [Brands]

-- Filtering

SELECT * FROM [Products]
WHERE ([ProductID] > 10)

SELECT * FROM [Products]
WHERE ([BrandID] = 2)

SELECT * FROM [Brands]
WHERE ([Name] IN (N'Coca-Cola', N'Fanta', N'Sprite', N'Schweppes'))
  AND ([Description] IS NOT NULL)

SELECT * FROM [Brands]
WHERE ([BrandID] NOT IN (SELECT DISTINCT [BrandID] FROM [Products]))

-- Sorting

SELECT * FROM [Brands]
ORDER BY [Name]

SELECT * FROM [Products]
ORDER BY [EnergyValue] DESC, [Name] ASC

-- Aggregation

SELECT COUNT([Description]) FROM [Brands]

SELECT COUNT(*) FROM [Products]
WHERE ([BrandID] = 4)

SELECT COUNT(DISTINCT [BrandID]) FROM [Products]

-- Grouping

SELECT [BrandID], AVG([EnergyValue]) FROM [Products]
GROUP BY [BrandID]

SELECT [BrandID], COUNT(*) FROM [Products]
GROUP BY [BrandID]
HAVING (COUNT(*) > 1)

-- Joining

SELECT [P].[ProductID], [B].[Name] AS [BrandName], [P].[Name] AS [ProductName]
FROM [Products] AS [P] INNER JOIN
	 [Brands] AS [B] ON ([P].[BrandID] = [B].[BrandID])

SELECT [P].[Name] AS [ProducerName], COUNT([B].[BrandID]) AS [BrandCount]
FROM [Producers] AS [P] LEFT OUTER JOIN
	 [Brands] AS [B] ON ([P].[ProducerID] = [B].[ProducerID])
GROUP BY [P].[Name]
